#ifndef JEU_H_INCLUDED
#define JEU_H_INCLUDED

#include <SDL.h>
#include "Liner.h"
#include "Collisions.h"
#include "Power.h"
#include "TextRender.h"
#include "Starter.h"
#include "intToStr.h"

#include <fstream>// Pour readConfig()

// Couleurs
#define ROUGE 128, 0, 0
#define BLEU 0, 0, 128
#define VERT 0, 128, 0
#define JAUNE 128, 128, 0
#define ROSE 128, 0, 128
#define CYAN 0, 128, 128
#define ORANGE 128, 64, 0
#define VIOLET 64, 0, 60
#define GRIS 64, 64, 64
#define MARINE 0, 0, 64
#define PLUME 32, 64, 128
#define MARRON 64, 32, 0

 struct Config
 {
     int xSize;
     int ySize;
     int nbJoueurs;
     bool pleinEcran;
     int nbPouvoirs;

     std::string pseudo[12];
     int cmd[12][3];
 };

 struct Score
 {
     Uint32 frag[12]; // Stocke le nombre de frags de chaque joueur
     Uint32 mort[12]; // Nb de morts
 };

int jeuMulti( SDL_Surface* screen, Config settings );
/** \brief Permet de lancer le mode de jeu en multi-joueur
 *
 * \param SDL_Surface* contenant la surface dynamique de la fentre
 * \param int contenant le nombre de joueurs.
 * \return entier : 0 si pas d'erreur, autre si problme
 *
 */

//int jeuSolo( SDL_Surface* screen );
/** \brief Mode survie un joueur
 *
 * \param SDL_Surface* contenant la surface dynamique de la fentre
 * \param
 * \return entier : 0 si pas d'erreur, autre si problme
 *
 */

Config readConfig();
void updateScore( Score* tabScore, Liner** hyperliner, int nbJoueurs );
void displayScore( Score* tabScore, TextRender* texter, int nbJoueurs, SDL_Surface* screen, std::string pseudo[4] );
void clearScore ( Score* tabScore );

#endif // JEU_H_INCLUDED
