#include <iostream>
#include <SDL.h>

#include <cstdlib>
#include <ctime>

#include "jeu.h"

/** \brief Main de Mighty Liners
 * \last Init random
 * \next Importer pouvoirs
 *
 * \return entier : 0 si pas d'erreur, autre si problme
 *
 */


int main ( int argc, char** argv )
{
    /// [1] Dmarrage
    // [1.1] Dmarrages SDL
    if ( SDL_Init( SDL_INIT_VIDEO ) < 0)
    {
        std::cout << "Impossible d'initialiser la SDL: " << SDL_GetError() << std::endl;
        return 1;
    }

    // [1.2] Prparation de fermeture
    atexit(SDL_Quit);

    // [1.3] Para-fentre
    SDL_WM_SetCaption("Mighty Liners V2 - By Jovian", 0);

    // [1.4] Dmarrage de l'alatoire
    srand(time(0));

    /// [2] Prparation des composants
    // [2.0] Lecture des paramtres
    Config settings(readConfig());

    // [2.1] Prparation de la fentre
    Uint32 flags(SDL_HWSURFACE | SDL_DOUBLEBUF);
    if (settings.pleinEcran) flags |= SDL_FULLSCREEN;
    SDL_Surface* screen = SDL_SetVideoMode(settings.xSize*20, settings.ySize*20, 32, flags);
    if ( !screen )
    {
        std::cout << "Impossible de crer la fentre : " << SDL_GetError() << std::endl;
        return 1;
    }

    /// [3] Boucle principale
    int retour;
    retour = jeuMulti(screen, settings);

    /// [4] Destruction des composants
    SDL_FreeSurface(screen);

    std::cout << "Aucune erreur detectee." << std::endl;
    return retour;
}
