#ifndef RETOURNER_H_INCLUDED
#define RETOURNER_H_INCLUDED

#include <iostream>
#include <SDL.h>

SDL_Surface* retournement(SDL_Surface* originale, int nbQuarts);
/** retournement() \brief Permet de crer une nouvelle image pivote.
 *
 * SDL_Surface* originale \param Surface originale pour pivoter.
 * int nbQuarts \param Indique le nombre de quarts de tour  raliser, sens indirect.
 * SDL_Surface* \return La surface pivote. Attention ! Ne pas oublier freeSurface().
 *
 */

SDL_Surface* destroyColor(SDL_Surface* originale, bool blue, bool green, bool red);
/** destroyColor() \brief Permet de crer une nouvelle image en retirant des couleurs.
 *
 * SDL_Surface* originale \param Surface originale pour modifier.
 * bool blue \param Indique si cette couleur est  retirer.
 * bool green \param Indique si cette couleur est  retirer.
 * bool red \param Indique si cette couleur est  retirer.
 * SDL_Surface* \return La surface modifie. Attention ! Ne pas oublier freeSurface().
 *
 */

 SDL_Surface* colorMightyObjet(SDL_Surface* source, int id);
/** colorMightyObjet() \brief Utilise destroyColor() en fonction de l'identifiant.
 *
 * SDL_Surface* originale \param Surface originale pour modifier.
 * int id \param Contient l'identifiant du mightyLiner associ.
 * SDL_Surface* \return La surface modifie. Attention ! Ne pas oublier freeSurface().
 *
 */

#endif // RETOURNER_H_INCLUDED
